package com.cim.idm.framework.exception;

/**
 * <pre>
 ****************************************************************************
 *  PACKAGE : com.cim.idm.framework.exception
 *  NAME    : IDMFrameDBErrorSignal.java
 *  TYPE    : JAVA
 *  DESCRIPTION :
 *
 ****************************************************************************
 *<pre>
 */

public class IDMFrameDBErrorSignal extends IDMFrameErrorSignal //RuntimeException
{
	static final long	serialVersionUID	= 9023275698421312312L;

	private String		sql					= "";
	//SQL : BindSet of String 
	//ORM : DataKey of String
	private String		dataKey				= "";

	public IDMFrameDBErrorSignal(String errorCode, String msg)
	{
		super(errorCode, msg);
	}

	public IDMFrameDBErrorSignal(String errorCode, Throwable throwable)
	{
		super(errorCode, throwable.getMessage(), throwable);
	}

	public IDMFrameDBErrorSignal(String errorCode, String sql, Throwable throwable)
	{
		super(errorCode, String.format("%s [Sql=%s]", throwable.getMessage(), sql), throwable);
		this.sql = sql;
	}

	public IDMFrameDBErrorSignal(String errorCode, String dataKey, String sql)
	{
		super(errorCode, String.format("[DataKey=%s] [Sql=%s]", dataKey, sql));
		this.dataKey = dataKey;
		this.sql = sql;
	}

	public IDMFrameDBErrorSignal(String errorCode, String dataKey, String sql, Throwable throwable)
	{

		super(errorCode, String.format("%s [DataKey=%s] [Sql=%s]", throwable.getMessage(), dataKey, sql), throwable);
		this.dataKey = dataKey;
		this.sql = sql;
	}

	public IDMFrameDBErrorSignal(String errorCode, String dataKey, String sql, String msg)
	{
		super(errorCode, String.format("%s [DataKey=%s] [Sql=%s]", msg, dataKey, sql));
		this.dataKey = dataKey;
		this.sql = sql;
	}

	public IDMFrameDBErrorSignal(String errorCode, String dataKey, String sql, String msg, Throwable throwable)
	{
		super(errorCode, String.format("%s [DataKey=%s] [Sql=%s]", msg, dataKey, sql), throwable);
		this.dataKey = dataKey;
		this.sql = sql;
	}

	public String getSql()
	{
		return sql;
	}

	public String getDataKey()
	{
		return dataKey;
	}

}
