package com.cim.idm.framework.exception;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**<pre>
 ****************************************************************************
 *  PACKAGE : com.cim.idm.framework.exception
 *  NAME    : idmFrameErrorSignal.java
 *  TYPE    : JAVA
 *  DESCRIPTION :
 *
 ****************************************************************************
 *</pre>
 */

public class IDMFrameErrorSignal extends RuntimeException
{
	static final long	serialVersionUID	= 9023275698421312312L;
	protected Log		log					= LogFactory.getLog(this.getClass());

	private String		errorCode;

	public IDMFrameErrorSignal(String errorCode, Throwable throwable)
	{
		super(makeMessage(errorCode, throwable.getMessage()));
		this.errorCode = errorCode;
		
		if ( log.isDebugEnabled())
			log.debug(super.getMessage());
	}

	public IDMFrameErrorSignal(String errorCode, String msg)
	{
		super(makeMessage(errorCode, msg));
		this.errorCode = errorCode;
		
		if ( log.isDebugEnabled())
			log.debug(super.getMessage());
	}

	public IDMFrameErrorSignal(String errorCode, String msg, Throwable throwable)
	{
		super(makeMessage(errorCode, msg), throwable);
		this.errorCode = errorCode;
		
		if ( log.isDebugEnabled())
			log.debug(super.getMessage());
	}

	public String getErrorCode()
	{
		return errorCode;
	}

	public static String makeMessage(String errorCode, String msg)
	{
		return String.format("%s: %s", errorCode, msg);
	}
}
