package com.cim.idm.framework.exception.ext;

import java.text.MessageFormat;
import java.util.Locale;
import java.util.ResourceBundle;

import org.apache.commons.lang3.StringUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.cim.idm.framework.util.support.StackTraceUtils;

public class ExceptionMessages 
{

	protected static final Log				log	= LogFactory.getLog(ExceptionMessages.class);
	
	protected static ResourceBundle bundle=ResourceBundle.getBundle("exception",Locale.getDefault());
	
	/*
	 * public void setBundleContext(BundleContext arg0) { this.bundleContext = arg0;
	 * 
	 * String language = System.getProperty("user.language"); if
	 * (StringUtils.isEmpty(language)) { Locale locale = Locale.getDefault();
	 * language = locale.getLanguage(); }
	 * 
	 * String resourcePath = "/META-INF/exception/" + "exception_" + language;
	 * log.debug("Exception Resource Path : " + resourcePath); InputStream in =
	 * BundleUtil.getBundleResourceFile(this.bundleContext.getBundle(),
	 * resourcePath, "properties");
	 * 
	 * if (in == null && !"en".equals(language)) { resourcePath =
	 * "/META-INF/exception/" + "exception_en"; in =
	 * BundleUtil.getBundleResourceFile(this.bundleContext.getBundle(),
	 * resourcePath, "properties"); log.debug("DEFAULT : Exception Resource Path : "
	 * + resourcePath); }
	 * 
	 * props = new Properties(); try { props.load(in);
	 * 
	 * StringBuffer strBuffer = new StringBuffer();
	 * strBuffer.append("Load Exception Message Resource");
	 * strBuffer.append(SystemPropHelper.CR); for (Object key : props.keySet()) {
	 * strBuffer.append(StringUtils.rightPad((String) key, 50));
	 * strBuffer.append("\t"); strBuffer.append(props.getProperty((String) key));
	 * strBuffer.append(SystemPropHelper.CR); } log.debug(strBuffer.toString()); }
	 * catch (Exception e) { if (log.isDebugEnabled()) log.error(e, e); else
	 * log.error(e); } }
	 */
	
	
	private static class Holder {
        private static ExceptionMessages instance = new ExceptionMessages();
    }
 
    public static ExceptionMessages getInstance() {
        return Holder.instance;
    }
    
	public ExceptionMessages()
	{
	}
	
	public String getString(String key)
	{
		/*
		 * try { return props.getProperty(key); } catch (MissingResourceException e) {
		 * return '!' + key + '!'; }
		 */
		return bundle.getString(key);
	}

	//	public String format(String aKey, Object aParam)
	//	{
	//		return format(aKey, new Object[] { aParam });
	//	}

	public String format(String aKey, Object[] aArgs)
	{
		
		Object[] fullArgs = preAppendOperation(aArgs);
		return _format(aKey, fullArgs);
	}

	@SuppressWarnings("unchecked")
	public String format(String aKey, Class serviceClass, String operation, Object[] aArgs)
	{
		Object[] fullArgs = preAppendOperation(serviceClass, operation, aArgs);
		return _format(aKey, fullArgs);
	}

	protected String _format(String aKey, Object[] aArgs)
	{
		String template = getString(aKey);
		if (StringUtils.isEmpty(template))
		{
			return getDefaultMessage(aKey, aArgs);
		}

		return MessageFormat.format(template, aArgs);
	}

	protected String getDefaultMessage(String aKey, Object[] aArgs)
	{
		StringBuilder builder = new StringBuilder();
		builder.append("!");
		builder.append(aKey);
		builder.append("! [");
		if (aArgs.length > 0)
		{
			for (Object arg : aArgs)
			{
				builder.append(arg);
				builder.append(", ");
			}
			builder.delete(builder.length() - 2, builder.length());
		}
		builder.append("]");
		return builder.toString();
	}

	public Object[] preAppendOperation(Object[] args)
	{
		Object[] fullArgs = preAppend(args, StackTraceUtils.getServiceOperation());
		return fullArgs;
	}

	public Object[] preAppendOperation(Class serviceClass, String operation, Object[] aArgs)
	{
		Object[] fullArgs = preAppend(aArgs, getServiceOperation(serviceClass, operation));
		return fullArgs;
	}

	@SuppressWarnings("unchecked")
	public String getServiceOperation(Class serviceClass, String operation)
	{
		String serviceOperation = StackTraceUtils.getServiceOperation();
		if (serviceOperation.equals("Unknown") == false)
			return serviceOperation;

		if (serviceClass == null)
		{
			return StringUtils.isEmpty(operation) ? "" : "Unknown." + operation;
		}
		else if (serviceClass.getSimpleName().endsWith("Impl"))
		{
			return serviceClass.getSimpleName().substring(0, serviceClass.getSimpleName().length() - 4)
				+ "."
				+ operation;
		}
		else
		{
			return serviceClass.getSimpleName() + "." + operation;
		}
	}

	public Object[] preAppend(Object[] src, Object... elements)
	{
		if (elements == null || elements.length == 0)
			return src;

		if (src == null)
		{
			return elements;
		}
		else
		{
			Object[] newArray = new Object[src.length + elements.length];

			System.arraycopy(elements, 0, newArray, 0, elements.length);
			System.arraycopy(src, 0, newArray, elements.length, src.length);

			return newArray;
		}
	}

}
