package com.cim.idm.framework.util.support;

import org.apache.commons.lang3.StringUtils;

/**
 ****************************************************************************
 *  PACKAGE : com.cim.idm.framework.util.support <br>
 *  NAME    : StackTraceUtils.java <br>
 *  TYPE    : JAVA <br>
 *  DESCRIPTION : Get the serviceOperation from the file.
 *
 ****************************************************************************
 */

public class StackTraceUtils
{
	public static String getServiceOperation()
	{
		for (StackTraceElement traceElement : Thread.currentThread().getStackTrace())
		{
			if (traceElement.getClassName().endsWith("ServiceImpl"))
			{
				String[] strs = StringUtils.split(traceElement.getClassName(), '.');

				String service = strs[strs.length - 1].substring(0, strs[strs.length - 1].length() - 4);
				String operation = traceElement.getMethodName();
				return service + "." + operation;
			}
//			else 
//			{
//				return "Could not find operation name";
//			}

		}
		return "Unknown";
	}
}
